Subject: Re: bug#65896: 30.0.50; folding text with text properties prevents background from extending past the newline

From: Ihor Radchenko <[email-masked]>
Date: Fri, 22 Sep 2023 10:12:57 +0000

Eli Zaretskii <[email-masked]> writes:

>> Are you sure? I am looking at `extend_face_to_end_of_line' and it looks
>> like there is nothing preventing it from accessing it->glyph_row->glyphs
>> array to look backwards into preceding glyphs.
>
> First, glyphs have only partial information about the original face
> properties.  IOW, the produced glyph row doesn't have all the info
> that the original text had.
>
> And second, I don't see how the accessibility to the glyphs is
> relevant to the issue at hand.  Suppose the visible text of a line is:
>
>    aaabbbbxxx
>
> where each letter represents some character with different face -- you
> want Emacs to extend face 'a' after the end of the line, not the face
> 'x', just because the line started with characters whose face was
> 'a'?? that's what the OP said, AFAIU.

I am also not a big fan of using the first glyph/letter in the line.

What about not extending the face unless the last 2 glyphs have eq face
or we have a single glyph in a row?

-- 
Ihor Radchenko // yantar92,
Org mode contributor,
Learn more about Org mode at <https://orgmode.org/>.
Support Org development at <https://liberapay.com/org-mode>,
or support my work at <https://liberapay.com/yantar92>